from pymoo.algorithms.moo.nsga2 import NSGA2
from pymoo.problems import get_problem
from pymoo.optimize import minimize
from pymoo.visualization.scatter import Scatter
import numpy as np

problem = get_problem("osy")
# n_var=6, n_obj=2, n_ieq_constr=6

algorithm = NSGA2(pop_size=200)

res = minimize(problem,
               algorithm,
               ('n_gen', 250),
               seed=1,
               verbose=False)

# print( res.X.shape )
# print( res.F.shape )
# print( res.CV.shape )
# print( res.G.shape )
# print( res.H.shape )
# print( res.pop.shape )
# print( res.pf )
# print("Soluciones factibles = ", res.feas )

# Vamos a guardar la solución
np.savetxt( "vars.txt", res.X  )
np.savetxt( "objs.txt", res.F  )
np.savetxt( "feas.txt", res.CV  )
np.savetxt( "const.txt", res.G  )

# X (200, 6) Son las 200 soluciones con sus 6 variables
# F (200, 2) Son las 200 soluciones con los 2 valores de la función objetivo
# CV (200, 1) Indica las soluciones que son factibles
# G (200, 6) Son las 200 soluciones con los 6 valores de las restricciones
# H (200, 0) No hay restricciones de igualdad
# pop (200,) Población final


# plot = Scatter()
# plot.add(problem.pareto_front(), plot_type="line", color="black", alpha=0.7)
# plot.add(res.F, facecolor="none", edgecolor="red")
# plot.show()
